<template>
  <div class="search">
    <b-container>
      <coscine-headline :headline="$t('headline')" />
      <b-row id="mainRow">
        <!-- Sidebar -->
        <Sidebar />
        <!-- Sidebar -->

        <b-col ref="rightCol" sm="10" align-self="end" style="height: 100%">
          <!-- Search Bar Fields -->
          <b-row id="searchBarContainer" align-content="center">
            <b-col id="searchField" align-self="start" class="pl-0">
              <b-form-input
                v-model="searchText"
                :placeholder="$t('search')"
              ></b-form-input>
            </b-col>
            <b-col sm="2" id="selectProjCol" align-self="center" class="pl-0">
              <b-form-select v-model="selectProjValue">
                <template #first>
                  <b-form-select-option :value="null" disabled
                    >{{ $t("allProjects") }}
                  </b-form-select-option>
                </template>
              </b-form-select>
            </b-col>
            <b-col sm="2" id="selectResCol" align-self="center" class="pl-0">
              <b-form-select v-model="selectResValue">
                <template #first>
                  <b-form-select-option :value="null" disabled
                    >{{ $t("allResources") }}
                  </b-form-select-option>
                </template>
              </b-form-select>
            </b-col>
            <b-col sm="0" align-self="center" class="text-right p-0">
              <b-button-group>
                <b-button id="searchButton" variant="primary">
                  {{ $t("search") }}
                </b-button>
                <b-dropdown
                  id="searchDropdown"
                  right
                  size="sm"
                  variant="primary"
                >
                  <b-dropdown-item>{{ $t("btnSearchItem1") }}</b-dropdown-item>
                  <b-dropdown-item>{{ $t("btnSearchItem2") }}</b-dropdown-item>
                </b-dropdown>
              </b-button-group>
            </b-col>
          </b-row>
          <!-- Search Bar Fields -->

          <!-- Filter Tags -->
          <b-row
            id="filterTagsContainer"
            align-self="center"
            class="mt-2 mb-2 rounded bg-light"
            style="min-height: 37px"
          >
            <b-col align-self="center" class="pl-0">
              <b-form-tags
                v-model="filterTags"
                no-outer-focus
                class="border-0 bg-transparent"
              >
                <template v-slot="{ tags, removeTag }">
                  <div>
                    <b-form-tag
                      v-for="tag in tags"
                      @remove="removeTag(tag)"
                      :key="tag"
                      :title="tag"
                      variant="primary"
                      pill
                      class="mr-1"
                      >{{ tag }}
                    </b-form-tag>
                  </div>
                </template>
              </b-form-tags>
            </b-col>
            <b-col align-self="center" sm="1" class="text-right">
              <b-button id="filterTagsButton" size="sm" variant="light">
                <BIconFunnelFill class="icon-tiny" />
              </b-button>
            </b-col>
          </b-row>
          <!-- Filter Tags -->

          <!-- Results View -->
          <b-row id="resultsViewContainer" class="flex-grow-1">
            <b-card style="width: 100%">
              <b-skeleton-wrapper :loading="resultsViewLoading">
                <template #loading>
                  <div
                    v-for="(entry, index) in 3"
                    :key="index"
                    class="p-2 border-top"
                    style="height: 105px"
                  >
                    <b-skeleton width="30%" class="m-2 mb-3"></b-skeleton>
                    <b-skeleton width="95%" class="m-2"></b-skeleton>
                    <b-skeleton width="40%" class="m-2"></b-skeleton>
                  </div>
                </template>
                <b-table
                  id="resultsView"
                  :items="resultsViewData"
                  :fields="resultsViewFields"
                  :per-page="paginationPerPage"
                  :current-page="paginationCurrentPage"
                  thead-class="d-none"
                  style="min-height: 100%"
                  small
                  hover
                  sticky-header
                  show-empty
                >
                  <template #cell(header)="data">
                    <Result :result="data.item" />
                  </template>

                  <template #empty>
                    <h6 class="text-center">
                      {{ $t("emptySearch") }}
                    </h6>
                  </template>

                  <template #custom-foot="foot">
                    <!-- Show footer if there are results and only on the last page -->
                    <div
                      v-if="
                        foot.items.length > 0 &&
                        paginationCurrentPage ===
                          Math.ceil(paginationTotalRows / paginationPerPage)
                      "
                      class="p-2 text-center text-muted border-top"
                    >
                      {{ $t("endSearchResults") }}
                    </div>
                  </template>
                </b-table>
              </b-skeleton-wrapper>
            </b-card>
          </b-row>
          <!-- Results View -->
        </b-col>
      </b-row>

      <!-- Pagination -->
      <b-row class="mt-1 mb-1 text-right" align-v="center">
        <b-col align-self="center" class="p-0" />
        <b-col align-self="center" class="p-0">
          <b-pagination
            id="pagination"
            v-model="paginationCurrentPage"
            :total-rows="paginationTotalRows"
            :per-page="paginationPerPage"
            aria-controls="resultsView"
            align="center"
          ></b-pagination>
        </b-col>
        <b-col align-self="center" class="p-0">
          <b-form-select
            v-model="paginationPerPage"
            :options="paginationPerPageOptions"
            style="max-width: 5rem"
          ></b-form-select>
        </b-col>
      </b-row>
      <!-- Pagination -->
    </b-container>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import { CoscineHeadline } from "@coscine/component-library";
import { BIconFunnelFill } from "bootstrap-vue";
import Result from "./Result.vue";
import Sidebar from "./Sidebar.vue";
import { mainViewData } from "@/assets/dummy_data";

export default Vue.extend({
  name: "Search",
  data() {
    return {
      searchText: "",
      selectProjValue: null,
      selectResValue: null,

      filterTags: ["Filter 1", "Filter 2", "Filter 3"],

      resultsViewData: mainViewData,
      resultsViewFields: ["header"],
      resultsViewLoading: true,

      paginationCurrentPage: 1,
      paginationPerPage: 10,
      paginationPerPageOptions: [5, 10, 20, 50, 100],
      paginationTotalRows: mainViewData.length,
    };
  },
  components: {
    BIconFunnelFill,
    CoscineHeadline,
    Result,
    Sidebar,
  },
  computed: {},
  mounted() {
    this.showResults();
  },
  methods: {
    showResults() {
      setTimeout(() => {
        this.resultsViewLoading = false;
      }, 1500);
    },
  },
});
</script>

<style scoped>
#mainRow {
  /* this style stretches the page vertically to fit the screen */
  height: calc(100vh - 100px);
}
#pagination {
  margin-top: 0.5rem;
  margin-bottom: 0.5rem;
}
#resultsViewContainer {
  /* this style stretches the results table vertically */
  height: calc(100% - 91px);
}
.card-body {
  padding: 0rem;
}
</style>
